#include "mainwindow.h"
#include <QNetworkReply>
#include <iostream>



MainWindow::MainWindow(QWidget *parent)
  : QWebEngineView(parent),
    dataList   (      ),
    showCount  (   1  ),
    timeCount  (   0  ),
    loadStartTime( 0  )
{
  settings()->setAttribute( QWebEngineSettings::JavascriptEnabled, true );
  dataList.push_back("http://127.0.0.1:8080/?_=/contacts");
  dataList.push_back("http://127.0.0.1:8080/?_=/about");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/oilgas");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/chem");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/chem/agro-chem");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/chem/auto-chem");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/chem/chem-process");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/chem/chem-mind");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/chem/chem-raw");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/chem/silicone-cleaning");
  dataList.push_back("http://127.0.0.1:8080/?_=/monofacture/%d1%81onstruction");
  dataList.push_back("http://127.0.0.1:8080/?_=/news");
  dataList.push_back("http://127.0.0.1:8080/?_=/news/1456387988");
  dataList.push_back("http://127.0.0.1:8080/?_=/news/1455304682");
  dataList.push_back("http://127.0.0.1:8080/?_=/tech_info");
  dataList.push_back("http://127.0.0.1:8080/?_=/tech_info/physico-mechanical");
  dataList.push_back("http://127.0.0.1:8080/?_=/tech_info/electrical");
  dataList.push_back("http://127.0.0.1:8080/?_=/tech_info/operational%20properties");
  dataList.push_back("http://127.0.0.1:8080/?_=/tech_info/penoi_pravit_silicon");
  dataList.push_back("http://127.0.0.1:8080/?_=/production");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/general_purpose_rubbers");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/general_purpose_rubbers/silicone_rubber_RBB-2100-30");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/general_purpose_rubbers/silicone_rubber_RBB-2100-40");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/general_purpose_rubbers/silicone_rubber_RBB-2100-50");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/general_purpose_rubbers/silicone_rubber_RBB-2100-60");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/general_purpose_rubbers/silicone_rubber_RBB-2100-70");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/general_purpose_rubbers/silicone_rubber_RBB-2100-80");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/no_post_cure_rubbers");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/no_post_cure_rubbers/silicone_rubber_RBB-2130-40");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/no_post_cure_rubbers/silicone_rubber_RBB-2130-80");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/cable_rubbers");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/cable_rubbers/silicone_rubber_RBB-2140-50");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/high_strength_rubbers");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_rubbers/high_strength_rubbers/silicone_rubber_RBB-2110-70");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/zakaz");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/zakaz/zakaz_fluorosilicone_products");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/zakaz/zakaz_silicone_products");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_544");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_1500");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_1510");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_1520");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_2210");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_db_100");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_db_310");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/antifoam/antifoam_dc_apw-4248");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_fluids_and_emulsion");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_fluids_and_emulsion/pmx-200");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_fluids_and_emulsion/emulsion_MEM-0346");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/hydrophobing");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/hydrophobing/XIAMETER_MHX-1107");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-5");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-10");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-20");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-50");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-100");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-200");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-300");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-400");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-500");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/pms/pms-1000");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_profiles");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_cords");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_5_1.5");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_5_1");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_16_3");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_14_2");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_12_2");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_10_2");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_8_2");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_8_1.5");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_6_2");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_6_1.5");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_tubes/silicone_tube_4_1.5");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_2");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_3");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_4");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_5");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_6");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/500%d1%85500%d1%858");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_10");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_12");
  dataList.push_back("http://127.0.0.1:8080/?_=/production/silicone_sheets/silicone_sheet_500_500_15");

  //  this->setPage( new webPage( this ) );
  //  settings()->setAttribute( QWebSettings::JavaEnabled, true );
  createCenter();
  createBottom();
  QTimer::singleShot( 0, this, SLOT( loadUrl() ) );
}


MainWindow::~MainWindow()
{

}

//-------------------------------------------------------------------------------------
// Dsc: Создание центральной веб формы
//-------------------------------------------------------------------------------------
void MainWindow::createCenter()
{
  connect( this, SIGNAL( loadFinished(bool) ), this, SLOT( contentLoaded() ) );
}

//-------------------------------------------------------------------------------------
// Dsc: Создание подвала
//-------------------------------------------------------------------------------------
void MainWindow::createBottom()
{
}

//-------------------------------------------------------------------------------------
// Dsc:
//-------------------------------------------------------------------------------------
void MainWindow::updateLabelInfo()
{
//  if( showCount % 10 == 0 )
//    std::cout << ( "Load Count: " + QVariant( showCount ).toString() + ". S: " + QVariant( double( timeCount ) / showCount / 1000 ).toString().left(5) +
//                " sec/per/page" ).toUtf8().data() << std::endl;
}

//-------------------------------------------------------------------------------------
// Dsc: загрузка контента завершена
//-------------------------------------------------------------------------------------
void MainWindow::contentLoaded()
{
  ++showCount;
  timeCount += ( QDateTime::currentMSecsSinceEpoch() - loadStartTime )  ;
  updateLabelInfo();
  QTimer::singleShot( 0, this, SLOT(loadUrl()) );
  //  reload();
}


const char alphanum[] =
    "/!@#$%^&*()_+~0123456789"
    "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    "abcdefghijklmnopqrstuvwxyz";
int alphanumLength = sizeof(alphanum) - 1;

void randomString( QString &ret, int size)
{

  for( int i = 0; i < size; i++ )
  {
    ret += alphanum[ rand() % alphanumLength ];
  }
}

//-------------------------------------------------------------------------------------
// Dsc: Загрузить новый урел
//-------------------------------------------------------------------------------------
void MainWindow::loadUrl()
{
  loadStartTime = QDateTime::currentMSecsSinceEpoch();
  QString url;
  if( showCount >= dataList.size() )
    url = dataList[ random() % dataList.size() ];
  else
    url = dataList[ showCount ];

  int test = random() % 10;
  if( test == 0 )
  {
    randomString( url, random() % ( 2000 - url.size() ) );
  }

//  std::cout << ( "Load: " + url ).toUtf8().data() << std::endl;
  this->load( QUrl( url ) );
}

